<script setup lang="ts">
  import { genRandomString } from '@/helpers/genRandomString';

  withDefaults(
    defineProps<{
      checked?: boolean;
      errors?: any[];
      loading?: boolean;
      disabled?: boolean;
    }>(),
    {
      errors: () => [],
      loading: false,
      disabled: false,
    },
  );

  const id = `radio-${genRandomString()}`;

  defineEmits(['update:modelValue']);
</script>

<template>
  <div v-if="loading">
    <div class="items-top flex h-full animate-pulse flex-row space-x-5">
      <div class="mt-1 h-5 w-5 rounded-full bg-gray-300" />
      <div class="flex flex-col space-y-2">
        <div class="h-5 w-36 rounded-md bg-gray-300" />
        <div class="h-5 w-24 rounded-md bg-gray-300" />
      </div>
    </div>
  </div>

  <div v-else class="flex">
    <input
      :id="id"
      :checked="checked"
      type="radio"
      class="hidden"
      :disabled="disabled"
      @change="$emit('update:modelValue', value)"
    />

    <label :for="id">
      <div
        class="border-border flex h-5 w-5 items-center justify-center rounded-full border"
        :class="{ 'cursor-not-allowed': disabled }"
      >
        <div v-if="checked" class="bg-primary h-3 w-3 rounded-full" />
      </div>
    </label>

    <slot />
  </div>
</template>
